#!/bin/sh

RUBY_PREFIX="/usr/local"
RUBY_VERSION="1.9.3-p194"
RUBY_TARGET="${RUBY_PREFIX}/ruby"
CURRENT_DIR=`pwd`

# Paths for programs
RUBY_BUILD_BIN="/usr/local/bin/ruby-build"


# Install base packages
apt-get install -q -y openssh-server build-essential libreadline-dev zlib1g-dev libssl-dev libyaml-dev libxslt1-dev git

# Get ruby-build
RUBY_BUILD_DOWNLOAD_PATH="/tmp/ruby-build"
git clone git://github.com/sstephenson/ruby-build.git ${RUBY_BUILD_DOWNLOAD_PATH}
cd ${RUBY_BUILD_DOWNLOAD_PATH}
./install.sh

# Install ruby
RUBY_INSTALL_PATH="${RUBY_PREFIX}/ruby-${RUBY_VERSION}"
${RUBY_BUILD_BIN} ${RUBY_VERSION} ${RUBY_INSTALL_PATH}
ln -s ${RUBY_INSTALL_PATH} ${RUBY_TARGET}

# Add ruby home to the path
echo "PATH=\"/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games:${RUBY_TARGET}/bin\"" > /etc/environment
. /etc/environment
