define firefield::deployer ($deployer_user_home, $deployer_apps_dir) {

  user { $name :
      ensure => present,
      home => $deployer_user_home,
      managehome => true,
      shell => '/bin/bash'
    }

    file { $deployer_user_home :
      ensure => directory,
      owner => $name,
      require => User[$name]
    }

    # apps dir for deployer
    file { 'capistrano_apps' :
      path => $deployer_apps_dir,
      ensure => directory,
      owner => $name,
      require => User[$name]
    }

    # apps config dir for deployer
    file { 'deployer_config_dir' :
      path => "/etc/capistrano",
      ensure => directory,
      owner => $name,
      require => User[$name]
    }

    # .ssh dir
    file { 'ssh_home' :
      path => "${deployer_user_home}/.ssh",
      ensure => directory,
      owner => $name,
      mode => 0700,
      require => User[$name]
    }

    # add_keys_to_username
    # Tool for add keys to the deployer
    file { "add_key_to_deployer" :
      path    => "/usr/local/bin/add_key_to_${name}",
      ensure  => file,
      mode => 0755,
      content  => template("firefield/add_key_to_deployer/add_key_to_deployer.erb"),
      require => User[$name]
    }

    $backups_dir = "/var/backups/${name}"
    firefield::directory_with_parents { $backups_dir :}
    # Prepare on demand backup
    file { [$backups_dir] :
      ensure  => directory,
      mode => 0700,
      owner => $name,
      require => Directory_With_Parents[$backups_dir]
    }

}
