class firefield {

  # Save firewall configuration to disk
  exec { "firewall-persist":
    command => "/sbin/iptables-save > /var/lib/iptables/rules.v4",
    require => File ["/var/lib/iptables"],
    refreshonly => true,
  }

  class firewall_webserver () {
    firewall { '000 allow packets with valid state':
      state   => ['RELATED', 'ESTABLISHED'],
      action  => 'accept',
    }

    firewall { '001 allow ssh':
      proto  => 'tcp',
      dport  => '22',
      action => 'accept',
    }

    firewall { '001 allow icmp':
      proto   => 'icmp',
      action  => 'accept',
    }

    firewall { '002 allow all to lo interface':
      iniface => 'lo',
      action  => 'accept',
    }

    firewall { '100 allow http':
      proto  => 'tcp',
      dport  => '80',
      action => 'accept',
    }

    firewall { '999 drop everything else':
      action => 'drop',
    }

    resources { 'firewall':
      purge => true,
    }

  }

}
