class firefield {

  # Monit configuration
  # Monit services. Allowed values:
  # * localhost: Check server parameters
  # * passsenger: Check passenger

  class monit (
    $services = [],
    $monit_alert_recipients,
    $monit_conf_dir = '/etc/monit/conf.d'
    ) {


    package {'monit':
      ensure => installed,
    }

    # monitrc
    file { 'monitrc':
      path    => "/etc/monit/monitrc",
      ensure  => file,
      mode => 0600,
      content  => template("firefield/monitrc.erb"),
      require => Package['monit'],
    }

    # Write services
    monit_conf { $services :
      monit_conf_dir => $monit_conf_dir
    }

    service { 'monit':
      ensure => running,
      enable => true,
      hasstatus => true,
      hasrestart => true,
      require => File['monitrc'],
    }

  }

  define monit_conf(
    $monit_conf_dir = '/etc/monit/conf.d'
    ) {
    $service_name = "monit_${name}"
    file { $service_name:
      path    => "${monit_conf_dir}/${name}.conf",
      ensure  => file,
      content  => template("firefield/monit/${name}.conf.erb"),
      require => Package['monit'],
    }
  }
}
