# Postfix installation
class firefield {
  class postfix () {

    package {'postfix':
      ensure => installed,
    }

    # main.cf
    file { 'postfix_main':
      path    => "/etc/postfix/main.cf",
      ensure  => file,
      mode => 0644,
      content  => template("firefield/postfix_main.cf.erb"),
      require => Package['postfix'],
    }

    service { 'postfix':
      ensure => running,
      enable => true,
      hasstatus => true,
      hasrestart => true,
      require => File['postfix_main'],
    }

    # Realize all the backups
    Firefield::Postfix_rails_initializer <||>
  }


  # Virtual Resource for create the rails initializer
  define postfix_rails_initializer(
    $deployer_app_config_dir,
    $mailer_host
    ) {
    # mail_setup.rb initializer for rails
    file { "main_initializer_${name}" :
      path    => "${deployer_app_config_dir}/mail_setup.rb",
      ensure  => file,
      mode => 0644,
      content  => template("firefield/mail_setup.rb.erb"),
      require => Package['postfix'],
    }
  }

}
