class firefield {

  define rails_app(
    $db_name,
    $db_user,
    $db_pass,
    $domains,
    $mailer_host = '',
    )
    {

      # TODO
      $deployer_user = "deployer"
      $deployer_user_home = "/home/deployer"
      $deployer_apps_dir = "${deployer_user_home}/apps"

      $deployer_app_config_dir = "/etc/capistrano/${name}"
      $application_deploy_dir = "${deployer_apps_dir}/${name}"
      $application_current_dir = "${$application_deploy_dir}/current"


      # Create the app dir for the deployer
      file { "deployer_config_${name}" :
        path => $deployer_app_config_dir,
        ensure => directory,
        recurse => true,
        owner => $deployer_user,
        # require => File['deployer_config_dir'],
      }

      # Configure passenger vhost
      firefield::passenger_vhost { $name :
        domains => $domains,
        app_dir => $application_current_dir
      }


      # Setup mysql and create db
      firefield::mysql_db { $db_name :
        db_user => $db_user,
        db_pass => $db_pass,
      }

      # Application database
      file { "database config_${name}":
        path    => "${deployer_app_config_dir}/database.yml",
        ensure  => file,
        mode => 0644, # TODO fix that
        content  => template("firefield/mysql_database.yml.erb"),
        require => File["deployer_config_${name}"],
      }

      # Virtual resource for backups
      @firefield::backup_def_rails_app { $name :
        db_name => $db_name,
        db_user => $db_user,
        db_pass => $db_pass,
        application_deploy_dir => $application_deploy_dir,
      }

      firefield::on_demand_backup { $name :
        db_name => $db_name,
        db_user => $db_user,
        db_pass => $db_pass,
        application_deploy_dir => $application_deploy_dir,
        path => "${deployer_app_config_dir}/backup.rb",
      }

      $receipes_dir = "${deployer_user_home}/receipes/${name}"
      firefield::directory_with_parents { $receipes_dir :}
      # Create a sample deploy.rb
      file { "deploy_${name}.rb" :
        path    => "${receipes_dir}/deploy.rb",
        ensure  => file,
        content  => template("firefield/deploy.rb.erb"),
        require => Directory_with_parents[$receipes_dir]
      }

      # Create virtual resource for the postfix initializer
      @firefield::postfix_rails_initializer { $name :
        deployer_app_config_dir => $deployer_app_config_dir,
        mailer_host => $mailer_host
      }

    }
}
