class firefield {

  class rails_server(
    $monit_alert_recipients,
    $deployer_user = 'deployer',
    $ruby_home = '/usr/local/ruby',
    $monit_conf_dir = '/etc/monit/conf.d',
    $deployer_user_home = "/home/deployer",
    ) {

    # App vars
    #=====================================================================

    $deployer_apps_dir = "${deployer_user_home}/apps"
    $nginx_install_dir = '/opt/nginx'

    # System vars
    Exec { path => ['/bin', '/usr/bin', '/usr/sbin', "${ruby_home}/bin" ] }

    # Node js for rails is recomended in production
    package { 'nodejs' :
      ensure => installed,
    }

    # Install bundle
    package { 'bundle' :
      ensure => installed,
      provider => 'gem'
    }

    # deployer user and home
    firefield::deployer { $deployer_user :
      deployer_user_home => $deployer_user_home,
      deployer_apps_dir => "${deployer_user_home}/apps",
    }

    # Create sudoers file
    firefield::sudoers { 'sudoers':
      deployer_user => $deployer_user,
      ruby_home => $ruby_home
    }

    # Setup mysql and create db
    class { 'firefield::mysql' : }

    # Install passenger
    class { 'firefield::passenger' : }

    # Install a postfix for delivery emails
    class { 'firefield::postfix' : }

    # Monit daemon
    class { 'firefield::monit' :
      monit_alert_recipients => $monit_alert_recipients,
      monit_conf_dir => $monit_conf_dir,
      services => ['server', 'ssh', 'passenger', 'mysql', 'postfix']
    }

  }
}
